diff -c -r -N --exclude exp --exclude compile sys/arch/arm32.orig/mainbus/wd.c sys/arch/arm32/mainbus/wd.c
*** sys/arch/arm32.orig/mainbus/wd.c	Wed Jun 12 22:41:10 1996
--- sys/arch/arm32/mainbus/wd.c	Thu Jun 13 03:11:10 1996
***************
*** 1036,1057 ****
  	struct wd_softc *wd;
  {
  	struct disklabel *lp = wd->sc_dk.dk_label;
  	char *errstring;
  
  	bzero(lp, sizeof(struct disklabel));
  	bzero(wd->sc_dk.dk_cpulabel, sizeof(struct cpu_disklabel));
  
  	lp->d_secsize = DEV_BSIZE;
! 	lp->d_ntracks = wd->sc_params.wdp_heads;
! 	lp->d_nsectors = wd->sc_params.wdp_sectors;
! 	lp->d_ncylinders = wd->sc_params.wdp_cylinders;
  	lp->d_secpercyl = lp->d_ntracks * lp->d_nsectors;
  
  #if 0
  	strncpy(lp->d_typename, "ST506 disk", 16);
  	lp->d_type = DTYPE_ST506;
  #endif
! 	strncpy(lp->d_packname, wd->sc_params.wdp_model, 16);
  	lp->d_secperunit = lp->d_secpercyl * lp->d_ncylinders;
  	lp->d_rpm = 3600;
  	lp->d_interleave = 1;
--- 492,518 ----
  	struct wd_softc *wd;
  {
  	struct disklabel *lp = wd->sc_dk.dk_label;
+ 	struct wd_link *d_link = wd->d_link;
  	char *errstring;
  
+ #ifdef WDDEBUG
+     printf("wdgetdisklabel\n");
+ #endif
+ 
  	bzero(lp, sizeof(struct disklabel));
  	bzero(wd->sc_dk.dk_cpulabel, sizeof(struct cpu_disklabel));
  
  	lp->d_secsize = DEV_BSIZE;
! 	lp->d_ntracks = d_link->sc_params.wdp_heads;
! 	lp->d_nsectors = d_link->sc_params.wdp_sectors;
! 	lp->d_ncylinders = d_link->sc_params.wdp_cylinders;
  	lp->d_secpercyl = lp->d_ntracks * lp->d_nsectors;
  
  #if 0
  	strncpy(lp->d_typename, "ST506 disk", 16);
  	lp->d_type = DTYPE_ST506;
  #endif
! 	strncpy(lp->d_packname, d_link->sc_params.wdp_model, 16);
  	lp->d_secperunit = lp->d_secpercyl * lp->d_ncylinders;
  	lp->d_rpm = 3600;
  	lp->d_interleave = 1;
***************
*** 1067,1076 ****
  	lp->d_magic2 = DISKMAGIC;
  	lp->d_checksum = dkcksum(lp);
  
! 	wd->sc_badsect[0] = -1;
  
! 	if (wd->sc_state > RECAL)
! 		wd->sc_state = RECAL;
  	errstring = readdisklabel(MAKEWDDEV(0, wd->sc_dev.dv_unit, RAW_PART),
  	    wdstrategy, lp, wd->sc_dk.dk_cpulabel);
  	if (errstring) {
--- 528,537 ----
  	lp->d_magic2 = DISKMAGIC;
  	lp->d_checksum = dkcksum(lp);
  
! 	d_link->sc_badsect[0] = -1;
  
! 	if (d_link->sc_state > RECAL)
! 		d_link->sc_state = RECAL;
  	errstring = readdisklabel(MAKEWDDEV(0, wd->sc_dev.dv_unit, RAW_PART),
  	    wdstrategy, lp, wd->sc_dk.dk_cpulabel);
  	if (errstring) {
***************
*** 1080,1087 ****
  		 * assume the DOS geometry is now in the label and try
  		 * again.  XXX This is a kluge.
  		 */
! 		if (wd->sc_state > GEOMETRY)
! 			wd->sc_state = GEOMETRY;
  		errstring = readdisklabel(MAKEWDDEV(0, wd->sc_dev.dv_unit, RAW_PART),
  		    wdstrategy, lp, wd->sc_dk.dk_cpulabel);
  	}
--- 541,548 ----
  		 * assume the DOS geometry is now in the label and try
  		 * again.  XXX This is a kluge.
  		 */
! 		if (d_link->sc_state > GEOMETRY)
! 			d_link->sc_state = GEOMETRY;
  		errstring = readdisklabel(MAKEWDDEV(0, wd->sc_dev.dv_unit, RAW_PART),
  		    wdstrategy, lp, wd->sc_dk.dk_cpulabel);
  	}
***************
*** 1090,1359 ****
  		return;
  	}
  
! 	if (wd->sc_state > GEOMETRY)
! 		wd->sc_state = GEOMETRY;
  	if ((lp->d_flags & D_BADSECT) != 0)
  		bad144intern(wd);
  }
  
- /*
-  * Implement operations needed before read/write.
-  * Returns 0 if operation still in progress, 1 if completed.
-  */
- int
- wdcontrol(wd)
- 	struct wd_softc *wd;
- {
- 	struct wdc_softc *wdc = (void *)wd->sc_dev.dv_parent;
-     
- 	switch (wd->sc_state) {
- 	case RECAL:			/* Set SDH, step rate, do recal. */
- 		if (wdcommandshort(wdc, wd->sc_drive, WDCC_RECAL) != 0) {
- 			wderror(wd, NULL, "wdcontrol: recal failed (1)");
- 			goto bad;
- 		}
- 		wd->sc_state = RECAL_WAIT;
- 		break;
- 
- 	case RECAL_WAIT:
- 		if (wdc->sc_status & WDCS_ERR) {
- 			wderror(wd, NULL, "wdcontrol: recal failed (2)");
- 			goto bad;
- 		}
- 		/* fall through */
- 	case GEOMETRY:
- 		if ((wd->sc_params.wdp_capabilities & WD_CAP_LBA) != 0)
- 			goto multimode;
- 		if (wdsetctlr(wd) != 0) {
- 			/* Already printed a message. */
- 			goto bad;
- 		}
- 		wd->sc_state = GEOMETRY_WAIT;
- 		break;
- 
- 	case GEOMETRY_WAIT:
- 		if (wdc->sc_status & WDCS_ERR) {
- 			wderror(wd, NULL, "wdcontrol: geometry failed");
- 			goto bad;
- 		}
- 		/* fall through */
- 	case MULTIMODE:
- 	multimode:
- 		if (wd->sc_mode != WDM_PIOMULTI)
- 			goto open;
- 		outb(wdc->sc_iobase+wd_seccnt, wd->sc_multiple);
- 		if (wdcommandshort(wdc, wd->sc_drive, WDCC_SETMULTI) != 0) {
- 			wderror(wd, NULL, "wdcontrol: setmulti failed (1)");
- 			goto bad;
- 		}
- 		wd->sc_state = MULTIMODE_WAIT;
- 		break;
- 
- 	case MULTIMODE_WAIT:
- 		if (wdc->sc_status & WDCS_ERR) {
- 			wderror(wd, NULL, "wdcontrol: setmulti failed (2)");
- 			goto bad;
- 		}
- 		/* fall through */
- 	case OPEN:
- 	open:
- 		wdc->sc_errors = 0;
- 		wd->sc_state = OPEN;
- 		/*
- 		 * The rest of the initialization can be done by normal means.
- 		 */
- 		return 1;
- 
- 	bad:
- 		wdcunwedge(wdc);
- 		return 0;
- 	}
- 
- 	wdc->sc_flags |= WDCF_ACTIVE;
- 	timeout(wdctimeout, wdc, WAITTIME);
- 	return 0;
- }
- 
- /*
-  * Wait for the drive to become ready and send a command.
-  * Return -1 if busy for too long or 0 otherwise.
-  * Assumes interrupts are blocked.
-  */
- int
- wdcommand(wd, command, cylin, head, sector, count)
- 	struct wd_softc *wd;
- 	int command;
- 	int cylin, head, sector, count;
- {
- 	struct wdc_softc *wdc = (void *)wd->sc_dev.dv_parent;
- 	int iobase = wdc->sc_iobase;
- 	int stat;
-     
- 	/* Select drive, head, and addressing mode. */
- 	outb(iobase+wd_sdh, WDSD_IBM | (wd->sc_drive << 4) | head);
- 
- 	/* Wait for it to become ready to accept a command. */
- 	if (command == WDCC_IDP)
- 		stat = wait_for_unbusy(wdc);
- 	else
- 		stat = wdcwait(wdc, WDCS_DRDY);
- 	if (stat < 0)
- 		return -1;
-     
- 	/* Load parameters. */
- 	if (wd->sc_dk.dk_label->d_type == DTYPE_ST506)
- 		outb(iobase+wd_precomp, wd->sc_dk.dk_label->d_precompcyl / 4);
- 	else
- 		outb(iobase+wd_features, 0);
- 	outb(iobase+wd_cyl_lo, cylin);
- 	outb(iobase+wd_cyl_hi, cylin >> 8);
- 	outb(iobase+wd_sector, sector);
- 	outb(iobase+wd_seccnt, count);
- 
- 	/* Send command. */
- 	outb(iobase+wd_command, command);
- 
- 	return 0;
- }
- 
- /*
-  * Simplified version of wdcommand().
-  */
- int
- wdcommandshort(wdc, drive, command)
- 	struct wdc_softc *wdc;
- 	int drive;
- 	int command;
- {
- 	int iobase = wdc->sc_iobase;
- 
- 	/* Select drive. */
- 	outb(iobase+wd_sdh, WDSD_IBM | (drive << 4));
- 
- 	if (wdcwait(wdc, WDCS_DRDY) < 0)
- 		return -1;
- 
- 	outb(iobase+wd_command, command);
- 
- 	return 0;
- }
  
  /*
   * Tell the drive what geometry to use.
   */
  int
! wdsetctlr(wd)
! 	struct wd_softc *wd;
  {
  
  #ifdef WDDEBUG
! 	printf("wd(%d,%d) C%dH%dS%d\n", wd->sc_dev.dv_unit, wd->sc_drive,
  	    wd->sc_dk.dk_label->d_ncylinders, wd->sc_dk.dk_label->d_ntracks,
  	    wd->sc_dk.dk_label->d_nsectors);
  #endif
      
! 	if (wdcommand(wd, WDCC_IDP, wd->sc_dk.dk_label->d_ncylinders,
! 	    wd->sc_dk.dk_label->d_ntracks - 1, 0,
! 	    wd->sc_dk.dk_label->d_nsectors) != 0) {
! 		wderror(wd, NULL, "wdsetctlr: geometry upload failed");
  		return -1;
  	}
  
  	return 0;
  }
  
- /*
-  * Get the drive parameters, if ESDI or ATA, or create fake ones for ST506.
-  */
  int
! wd_get_parms(wd)
! 	struct wd_softc *wd;
! {
! 	struct wdc_softc *wdc = (void *)wd->sc_dev.dv_parent;
! 	int i;
! 	char tb[DEV_BSIZE];
! 	int s, error;
! 
! 	/*
! 	 * XXX
! 	 * The locking done here, and the length of time this may keep the rest
! 	 * of the system suspended, is a kluge.  This should be rewritten to
! 	 * set up a transfer and queue it through wdstart(), but it's called
! 	 * infrequently enough that this isn't a pressing matter.
! 	 */
! 
! 	s = splbio();
! 
! 	while ((wdc->sc_flags & WDCF_ACTIVE) != 0) {
! 		wdc->sc_flags |= WDCF_WANTED;
! 		if ((error = tsleep(wdc, PRIBIO | PCATCH, "wdprm", 0)) != 0) {
! 			splx(s);
! 			return error;
! 		}
! 	}
! 
! 	if (wdcommandshort(wdc, wd->sc_drive, WDCC_IDENTIFY) != 0 ||
! 	    wait_for_drq(wdc) != 0) {
! 		/*
! 		 * We `know' there's a drive here; just assume it's old.
! 		 * This geometry is only used to read the MBR and print a
! 		 * (false) attach message.
! 		 */
! 		strncpy(wd->sc_dk.dk_label->d_typename, "ST506",
! 		    sizeof wd->sc_dk.dk_label->d_typename);
! 		wd->sc_dk.dk_label->d_type = DTYPE_ST506;
! 
! 		strncpy(wd->sc_params.wdp_model, "unknown",
! 		    sizeof wd->sc_params.wdp_model);
! 		wd->sc_params.wdp_config = WD_CFG_FIXED;
! 		wd->sc_params.wdp_cylinders = 1024;
! 		wd->sc_params.wdp_heads = 8;
! 		wd->sc_params.wdp_sectors = 17;
! 		wd->sc_params.wdp_maxmulti = 0;
! 		wd->sc_params.wdp_usedmovsd = 0;
! 		wd->sc_params.wdp_capabilities = 0;
! 	} else {
! 		strncpy(wd->sc_dk.dk_label->d_typename, "ESDI/IDE",
! 		    sizeof wd->sc_dk.dk_label->d_typename);
! 		wd->sc_dk.dk_label->d_type = DTYPE_ESDI;
! 
! 		/* Read in parameter block. */
! 		insw(wdc->sc_iobase+wd_data, tb, sizeof(tb) / sizeof(short));
! 		bcopy(tb, &wd->sc_params, sizeof(struct wdparams));
! 
! 		/* Shuffle string byte order. */
! 		for (i = 0; i < sizeof(wd->sc_params.wdp_model); i += 2) {
! 			u_short *p;
! 			p = (u_short *)(wd->sc_params.wdp_model + i);
! 			*p = ntohs(*p);
! 		}
! 	}
! 
! 	/* Clear any leftover interrupt. */
! 	(void) inb(wdc->sc_iobase+wd_status);
! 
! 	/* Restart the queue. */
! 	wdcstart(wdc);
! 
! 	splx(s);
! 	return 0;
! }
! 
! int
! wdioctl(dev, cmd, addr, flag, p)
  	dev_t dev;
! 	u_long cmd;
  	caddr_t addr;
  	int flag;
  	struct proc *p;
  {
  	struct wd_softc *wd = wd_cd.cd_devs[WDUNIT(dev)];
  	int error;
!     
! 	if ((wd->sc_flags & WDF_LOADED) == 0)
  		return EIO;
  
! 	switch (cmd) {
  	case DIOCSBAD:
  		if ((flag & FWRITE) == 0)
  			return EBADF;
--- 551,607 ----
  		return;
  	}
  
! 	if (d_link->sc_state > GEOMETRY)
! 		d_link->sc_state = GEOMETRY;
  	if ((lp->d_flags & D_BADSECT) != 0)
  		bad144intern(wd);
  }
  
  
  /*
   * Tell the drive what geometry to use.
   */
  int
! wdsetctlr(d_link)
! 	struct wd_link *d_link;
  {
+ 	struct wd_softc *wd=(struct wd_softc *)d_link->wd_softc;
  
  #ifdef WDDEBUG
! 	printf("wd(%d,%d) C%dH%dS%d\n", wd->sc_dev.dv_unit, d_link->sc_drive,
  	    wd->sc_dk.dk_label->d_ncylinders, wd->sc_dk.dk_label->d_ntracks,
  	    wd->sc_dk.dk_label->d_nsectors);
  #endif
      
! 	if (wdccommand(d_link, WDCC_IDP, d_link->sc_drive, wd->sc_dk.dk_label->d_ncylinders,
! 	    wd->sc_dk.dk_label->d_ntracks - 1, 0, wd->sc_dk.dk_label->d_nsectors)
! 	    != 0) {
! 		wderror(d_link, NULL, "wdsetctlr: geometry upload failed");
  		return -1;
  	}
  
  	return 0;
  }
  
  int
! wdioctl(dev, xfer, addr, flag, p)
  	dev_t dev;
! 	u_long xfer;
  	caddr_t addr;
  	int flag;
  	struct proc *p;
  {
  	struct wd_softc *wd = wd_cd.cd_devs[WDUNIT(dev)];
+ 	struct wd_link *d_link = wd->d_link;
  	int error;
! #ifdef WDDEBUG
!     printf("wdioctl\n");
! #endif
! 
! 	if ((d_link->sc_flags & WDF_LOADED) == 0)
  		return EIO;
  
! 	switch (xfer) {
  	case DIOCSBAD:
  		if ((flag & FWRITE) == 0)
  			return EBADF;
***************
*** 1377,1409 ****
  		if ((flag & FWRITE) == 0)
  			return EBADF;
  
! 		if ((error = wdlock(wd)) != 0)
  			return error;
! 		wd->sc_flags |= WDF_LABELLING;
  
  		error = setdisklabel(wd->sc_dk.dk_label,
  		    (struct disklabel *)addr, /*wd->sc_dk.dk_openmask : */0,
  		    wd->sc_dk.dk_cpulabel);
  		if (error == 0) {
! 			if (wd->sc_state > GEOMETRY)
! 				wd->sc_state = GEOMETRY;
! 			if (cmd == DIOCWDINFO)
  				error = writedisklabel(WDLABELDEV(dev),
  				    wdstrategy, wd->sc_dk.dk_label,
  				    wd->sc_dk.dk_cpulabel);
  		}
  
! 		wd->sc_flags &= ~WDF_LABELLING;
! 		wdunlock(wd);
  		return error;
  	
  	case DIOCWLABEL:
  		if ((flag & FWRITE) == 0)
  			return EBADF;
  		if (*(int *)addr)
! 			wd->sc_flags |= WDF_WLABEL;
  		else
! 			wd->sc_flags &= ~WDF_WLABEL;
  		return 0;
  	
  #ifdef notyet
--- 625,657 ----
  		if ((flag & FWRITE) == 0)
  			return EBADF;
  
! 		if ((error = wdlock(wd->d_link)) != 0)
  			return error;
! 		d_link->sc_flags |= WDF_LABELLING;
  
  		error = setdisklabel(wd->sc_dk.dk_label,
  		    (struct disklabel *)addr, /*wd->sc_dk.dk_openmask : */0,
  		    wd->sc_dk.dk_cpulabel);
  		if (error == 0) {
! 			if (d_link->sc_state > GEOMETRY)
! 				d_link->sc_state = GEOMETRY;
! 			if (xfer == DIOCWDINFO)
  				error = writedisklabel(WDLABELDEV(dev),
  				    wdstrategy, wd->sc_dk.dk_label,
  				    wd->sc_dk.dk_cpulabel);
  		}
  
! 		d_link->sc_flags &= ~WDF_LABELLING;
! 		wdunlock(d_link);
  		return error;
  	
  	case DIOCWLABEL:
  		if ((flag & FWRITE) == 0)
  			return EBADF;
  		if (*(int *)addr)
! 			d_link->sc_flags |= WDF_WLABEL;
  		else
! 			d_link->sc_flags &= ~WDF_WLABEL;
  		return 0;
  	
  #ifdef notyet
***************
*** 1433,1439 ****
  		return error;
  	}
  #endif
! 
  	default:
  		return ENOTTY;
  	}
--- 681,687 ----
  		return error;
  	}
  #endif
! 	
  	default:
  		return ENOTTY;
  	}
***************
*** 1460,1466 ****
  	struct wd_softc *wd;
  	int part;
  	int size;
!     
  	if (wdopen(dev, 0, S_IFBLK, NULL) != 0)
  		return -1;
  	wd = wd_cd.cd_devs[WDUNIT(dev)];
--- 708,717 ----
  	struct wd_softc *wd;
  	int part;
  	int size;
! #ifdef WDDEBUG
!     printf("wdsize\n");
! #endif
! 
  	if (wdopen(dev, 0, S_IFBLK, NULL) != 0)
  		return -1;
  	wd = wd_cd.cd_devs[WDUNIT(dev)];
***************
*** 1476,1484 ****
  
  
  #ifndef __BDEVSW_DUMP_OLD_TYPE
- /* #define WD_DUMP_NOT_TRUSTED if you just want to watch */
  static int wddoingadump;
! static int wddumprecalibrated;
  
  /*
   * Dump core after a system crash.
--- 727,734 ----
  
  
  #ifndef __BDEVSW_DUMP_OLD_TYPE
  static int wddoingadump;
! /*static int wddumprecalibrated;*/
  
  /*
   * Dump core after a system crash.
***************
*** 1491,1500 ****
          size_t size;
  {
  	struct wd_softc *wd;	/* disk unit to do the I/O */
! 	struct wdc_softc *wdc;	/* disk controller to do the I/O */
  	struct disklabel *lp;	/* disk's disklabel */
  	int	unit, part;
  	int	nblks;		/* total number of sectors left to write */
  
  	/* Check if recursive dump; if so, punt. */
  	if (wddoingadump)
--- 741,751 ----
          size_t size;
  {
  	struct wd_softc *wd;	/* disk unit to do the I/O */
! 	struct wd_link *d_link; /* link struct for this disk */
  	struct disklabel *lp;	/* disk's disklabel */
  	int	unit, part;
  	int	nblks;		/* total number of sectors left to write */
+ 	int err;
  
  	/* Check if recursive dump; if so, punt. */
  	if (wddoingadump)
***************
*** 1505,1521 ****
  	if (unit >= wd_cd.cd_ndevs)
  		return ENXIO;
  	wd = wd_cd.cd_devs[unit];
  	if (wd == 0)
  		return ENXIO;
  
  	part = WDPART(dev);
  
  	/* Make sure it was initialized. */
! 	if (wd->sc_state < OPEN)
  		return ENXIO;
  
- 	wdc = (void *)wd->sc_dev.dv_parent;
- 
          /* Convert to disk sectors.  Request must be a multiple of size. */
  	lp = wd->sc_dk.dk_label;
  	if ((size % lp->d_secsize) != 0)
--- 756,771 ----
  	if (unit >= wd_cd.cd_ndevs)
  		return ENXIO;
  	wd = wd_cd.cd_devs[unit];
+ 	d_link = wd->d_link;
  	if (wd == 0)
  		return ENXIO;
  
  	part = WDPART(dev);
  
  	/* Make sure it was initialized. */
! 	if (d_link->sc_state < OPEN)
  		return ENXIO;
  
          /* Convert to disk sectors.  Request must be a multiple of size. */
  	lp = wd->sc_dk.dk_label;
  	if ((size % lp->d_secsize) != 0)
***************
*** 1530,1614 ****
  	/* Offset block number to start of partition. */
  	blkno += lp->d_partitions[part].p_offset;
  
! 	/* Recalibrate, if first dump transfer. */
! 	if (wddumprecalibrated == 0) {
! 		wddumprecalibrated = 1;
! 		if (wdcommandshort(wdc, wd->sc_drive, WDCC_RECAL) != 0 ||
! 		    wait_for_ready(wdc) != 0 || wdsetctlr(wd) != 0 ||
! 		    wait_for_ready(wdc) != 0) {
! 			wderror(wd, NULL, "wddump: recal failed");
! 			return EIO;
! 		}
  	}
!    
! 	while (nblks > 0) {
! 		daddr_t xlt_blkno = blkno;
! 		long cylin, head, sector;
! 
! 		if ((lp->d_flags & D_BADSECT) != 0) {
! 			long blkdiff;
! 			int i;
! 
! 			for (i = 0; (blkdiff = wd->sc_badsect[i]) != -1; i++) {
! 				blkdiff -= xlt_blkno;
! 				if (blkdiff < 0)
! 					continue;
! 				if (blkdiff == 0) {
! 					/* Replace current block of transfer. */
! 					xlt_blkno = lp->d_secperunit -
! 					    lp->d_nsectors - i - 1;
! 				}
! 				break;
! 			}
! 			/* Tranfer is okay now. */
! 		}
! 
! 		if ((wd->sc_params.wdp_capabilities & WD_CAP_LBA) != 0) {
! 			sector = (xlt_blkno >> 0) & 0xff;
! 			cylin = (xlt_blkno >> 8) & 0xffff;
! 			head = (xlt_blkno >> 24) & 0xf;
! 			head |= WDSD_LBA;
! 		} else {
! 			sector = xlt_blkno % lp->d_nsectors;
! 			sector++;	/* Sectors begin with 1, not 0. */
! 			xlt_blkno /= lp->d_nsectors;
! 			head = xlt_blkno % lp->d_ntracks;
! 			xlt_blkno /= lp->d_ntracks;
! 			cylin = xlt_blkno;
! 			head |= WDSD_CHS;
! 		}
! 
! #ifndef WD_DUMP_NOT_TRUSTED
! 		if (wdcommand(wd, WDCC_WRITE, cylin, head, sector, 1) != 0 ||
! 		    wait_for_drq(wdc) != 0) {
! 			wderror(wd, NULL, "wddump: write failed");
! 			return EIO;
! 		}
! 	
! 		outsw(wdc->sc_iobase+wd_data, va, lp->d_secsize >> 1);
! 	
! 		/* Check data request (should be done). */
! 		if (wait_for_ready(wdc) != 0) {
! 			wderror(wd, NULL, "wddump: timeout waiting for ready");
! 			return EIO;
! 		}
! #else	/* WD_DUMP_NOT_TRUSTED */
! 		/* Let's just talk about this first... */
! 		printf("wd%d: dump addr 0x%x, cylin %d, head %d, sector %d\n",
! 		    unit, va, cylin, head, sector);
! 		delay(500 * 1000);	/* half a second */
! #endif
! 
! 		/* update block count */
! 		nblks -= 1;
! 		blkno += 1;
! 		va += lp->d_secsize;
! 	}
! 
! 	wddoingadump = 0;
! 	return 0;
  }
  #else /* __BDEVSW_DUMP_NEW_TYPE */
  int
  wddump(dev, blkno, va, size)
          dev_t dev;
--- 780,794 ----
  	/* Offset block number to start of partition. */
  	blkno += lp->d_partitions[part].p_offset;
  
! 	err =  wdcdump(d_link, blkno, nblks, va);
! 	if (err == 0) {
! 		wddoingadump = 0;
  	}
! 	return err;
  }
  #else /* __BDEVSW_DUMP_NEW_TYPE */
+ 
+ 
  int
  wddump(dev, blkno, va, size)
          dev_t dev;
***************
*** 1631,1789 ****
  {
  	struct dkbad *bt = &wd->sc_dk.dk_cpulabel->bad;
  	struct disklabel *lp = wd->sc_dk.dk_label;
  	int i = 0;
  
  	for (; i < 126; i++) {
  		if (bt->bt_bad[i].bt_cyl == 0xffff)
  			break;
! 		wd->sc_badsect[i] =
  		    bt->bt_bad[i].bt_cyl * lp->d_secpercyl +
  		    (bt->bt_bad[i].bt_trksec >> 8) * lp->d_nsectors +
  		    (bt->bt_bad[i].bt_trksec & 0xff);
  	}
  	for (; i < 127; i++)
! 		wd->sc_badsect[i] = -1;
! }
! 
! int
! wdcreset(wdc)
! 	struct wdc_softc *wdc;
! {
! 	int iobase = wdc->sc_iobase;
! 
! 	/* Reset the device. */
! 	if (wdresethack) {
! 		outb(iobase+wd_ctlr, WDCTL_RST | WDCTL_IDS);
! 		delay(1000);
! 		outb(iobase+wd_ctlr, WDCTL_IDS);
! 		delay(1000);
! 		(void) inb(iobase+wd_error);
! 		outb(iobase+wd_ctlr, WDCTL_4BIT);
! 	}
! 
! 	if (wait_for_unbusy(wdc) < 0) {
! 		printf("%s: reset failed\n", wdc->sc_dev.dv_xname);
! 		return 1;
! 	}
! 
! 	return 0;
! }
! 
! void
! wdcrestart(arg)
! 	void *arg;
! {
! 	struct wdc_softc *wdc = arg;
! 	int s;
! 
! 	s = splbio();
! 	wdcstart(wdc);
! 	splx(s);
  }
  
- /*
-  * Unwedge the controller after an unexpected error.  We do this by resetting
-  * it, marking all drives for recalibration, and stalling the queue for a short
-  * period to give the reset time to finish.
-  * NOTE: We use a timeout here, so this routine must not be called during
-  * autoconfig or dump.
-  */
  void
! wdcunwedge(wdc)
! 	struct wdc_softc *wdc;
! {
! 	int unit;
! 
! 	untimeout(wdctimeout, wdc);
! 	(void) wdcreset(wdc);
! 
! 	/* Schedule recalibrate for all drives on this controller. */
! 	for (unit = 0; unit < wd_cd.cd_ndevs; unit++) {
! 		struct wd_softc *wd = wd_cd.cd_devs[unit];
! 		if (!wd || (void *)wd->sc_dev.dv_parent != wdc)
! 			continue;
! 		if (wd->sc_state > RECAL)
! 			wd->sc_state = RECAL;
! 	}
! 
! 	wdc->sc_flags |= WDCF_ERROR;
! 	++wdc->sc_errors;
! 
! 	/* Wake up in a little bit and restart the operation. */
! 	timeout(wdcrestart, wdc, RECOVERYTIME);
! }
! 
! int
! wdcwait(wdc, mask)
! 	struct wdc_softc *wdc;
! 	int mask;
! {
! 	int iobase = wdc->sc_iobase;
! 	int timeout = 0;
! 	u_char status;
! #ifdef WDCNDELAY_DEBUG
! 	extern int cold;
! #endif
! 
! 	for (;;) {
! 		wdc->sc_status = status = inb(iobase+wd_status);
! 		if ((status & WDCS_BSY) == 0 && (status & mask) == mask)
! 			break;
! 		if (++timeout > WDCNDELAY)
! 			return -1;
! 		delay(WDCDELAY);
! 	}
! 	if (status & WDCS_ERR) {
! 		wdc->sc_error = inb(iobase+wd_error);
! 		return WDCS_ERR;
! 	}
! #ifdef WDCNDELAY_DEBUG
! 	/* After autoconfig, there should be no long delays. */
! 	if (!cold && timeout > WDCNDELAY_DEBUG)
! 		printf("%s: warning: busy-wait took %dus\n",
! 		    wdc->sc_dev.dv_xname, WDCDELAY * timeout);
! #endif
! 	return 0;
! }
! 
! void
! wdctimeout(arg)
! 	void *arg;
! {
! 	struct wdc_softc *wdc = (struct wdc_softc *)arg;
! 	int s;
! 
! 	s = splbio();
! 	if ((wdc->sc_flags & WDCF_ACTIVE) != 0) {
! 		struct wd_softc *wd = wdc->sc_drives.tqh_first;
! 		struct buf *bp = wd->sc_q.b_actf;
! 
! 		wdc->sc_flags &= ~WDCF_ACTIVE;
! 		wderror(wdc, NULL, "lost interrupt");
! 		printf("%s: lost interrupt: %sing %d@%s:%d (%d)\n",
! 		    wdc->sc_dev.dv_xname,
! 		    (bp->b_flags & B_READ) ? "read" : "writ",
! 		    wd->sc_nblks, wd->sc_dev.dv_xname, wd->sc_blkno, wd->sc_state);
! 		wdcunwedge(wdc);
! 	} else
! 		wderror(wdc, NULL, "missing untimeout");
! 	splx(s);
! }
! 
! void
! wderror(dev, bp, msg)
! 	void *dev;
  	struct buf *bp;
  	char *msg;
  {
! 	struct wd_softc *wd = dev;
! 	struct wdc_softc *wdc = dev;
  
  	if (bp) {
! 		diskerr(bp, "wd", msg, LOG_PRINTF, wd->sc_skip / DEV_BSIZE,
  		    wd->sc_dk.dk_label);
  		printf("\n");
  	} else
! 		printf("%s: %s: status %b error %b\n", wdc->sc_dev.dv_xname,
! 		    msg, wdc->sc_status, WDCS_BITS, wdc->sc_error, WDERR_BITS);
  }
--- 811,857 ----
  {
  	struct dkbad *bt = &wd->sc_dk.dk_cpulabel->bad;
  	struct disklabel *lp = wd->sc_dk.dk_label;
+ 	struct wd_link *d_link = wd->d_link;
  	int i = 0;
  
+ #ifdef WDDEBUG
+ 	printf("bad144intern\n");
+ #endif
+ 
  	for (; i < 126; i++) {
  		if (bt->bt_bad[i].bt_cyl == 0xffff)
  			break;
! 		d_link->sc_badsect[i] =
  		    bt->bt_bad[i].bt_cyl * lp->d_secpercyl +
  		    (bt->bt_bad[i].bt_trksec >> 8) * lp->d_nsectors +
  		    (bt->bt_bad[i].bt_trksec & 0xff);
  	}
  	for (; i < 127; i++)
! 		d_link->sc_badsect[i] = -1;
  }
  
  void
! wderror(d_link, bp, msg)
! 	struct wd_link *d_link;
  	struct buf *bp;
  	char *msg;
  {
! 	struct wd_softc *wd = (struct wd_softc *)d_link->wd_softc;
  
  	if (bp) {
! 		diskerr(bp, "wd", msg, LOG_PRINTF, bp->b_bcount ,
  		    wd->sc_dk.dk_label);
  		printf("\n");
  	} else
! 		printf("%s: %s\n", wd->sc_dev.dv_xname,
! 		    msg);
! }
! 
! void
! wddone(d_link, bp)
! struct wd_link *d_link;
! struct buf *bp;
! {
! 	struct wd_softc *wd = (void*)d_link->wd_softc;
! 	disk_unbusy(&wd->sc_dk, (bp->b_bcount - bp->b_resid));
  }
